<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.accessrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/accessrecord";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          menuWidth:350,
          column: [
            // {
            //   label: "用户id",
            //   prop: "userId",
            //   rules: [{
            //     required: true,
            //     message: "请输入用户id",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "用户姓名",
              prop: "userName",
              width:80,
              rules: [{
                required: true,
                message: "请输入用户姓名",
                trigger: "blur"
              }]
            },
            {
              label: "所属社区",
              prop: "agencyId",
              // slot: true,
              hide:true,
              type: "select",
              search: true,
              searchFilterable: true,
              cascaderItem: ['residentialId'],
              dicUrl: "/api/cyzh-community/agency/list?size=9999",
              props: {
                label: "name",
                value: "id"
              },
              dicFormatter: (res)=>{
                return res.data.records;
              },
              rules: [{
                required: true,
                message: "请选择所属社区",
                trigger: "blur"
              }]
            },{
              label: "所属小区",
              prop: "residentialId",
              // slot: true,
              type: "select",
              search: true,
              width:150,
              cascaderItem: ["buildingId"],
              // dicUrl: "/grid/estate/getResidentialList",
              // remote: true,
              //回显的时候有问题，如果所选不在前十条内，下拉框只会显示id
              dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}",
              dicFormatter: (res)=>{
                return res.data.records;
              },
              searchFilterable: true,
              // dicFlag: false,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请输入所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "所属企业",
              prop: "enterpriseId",
              type: "select",
              search: true,
              width:200,
              dicUrl: "/api/cyzh-enterprise/enterprise/list",
              props:{
                label:"enterpriseName",
                value:"id"
              },
              dicFormatter: (res)=>{
                return res.data.records;
              },
              searchFilterable: true,
              rules: [{
                required: true,
                message: "请输入企业id",
                trigger: "blur"
              }]
            },
            {
              label: "人脸",
              prop: "faceUrl",
              type:'upload',
              width:100,
              listType: 'picture-img',
              propsHttp: {
                res: "data",
                url: "link"
              },
              tip: '只能生产jpg/png图片，且不超过500kb',
              action: "/api/blade-resource/oss/endpoint/put-file",
              rules: [{
                required: true,
                message: "请输入人脸",
                trigger: "blur"
              }]
            },
            {
              label: "设备唯一标识",
              prop: "deviceId",
              hide:true,
              rules: [{
                required: true,
                message: "请输入设备唯一标识",
                trigger: "blur"
              }]
            },
            {
              label: "开门方式",
              prop: "openType",
              hide:true,
              type:"select",
              dicData:[
                {
                  label:'人脸',
                  value:1
                },{
                  label:'远程',
                  value:2
                }
              ],
              rules: [{
                required: true,
                message: "请输入开门方式{1->人脸，2->远程}",
                trigger: "blur"
              }]
            },
            {
              label: "体温(℃)",
              prop: "temperature",
              width:80,
              rules: [{
                required: true,
                message: "请输入体温",
                trigger: "blur"
              }]
            },
            {
              label: "小区名字",
              prop: "residentialName",
              rules: [{
                required: true,
                message: "请输入小区名字",
                trigger: "blur"
              }]
            },
            // {
            //   label: "企业名称",
            //   prop: "enterpriseName",
            //   rules: [{
            //     required: true,
            //     message: "请输入企业名称",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "机构类型",
            //   prop: "agencyType",
            //   rules: [{
            //     required: true,
            //     message: "请输入机构类型",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "设备位置",
              prop: "deviceAddress",
              rules: [{
                required: true,
                message: "请输入设备位置",
                trigger: "blur"
              }]
            },
            // {
            //   label: "机构名称",
            //   prop: "agencyName",
            //   rules: [{
            //     required: true,
            //     message: "请输入机构名称",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "设备mac码",
              prop: "deviceMac",
              hide:true,
              rules: [{
                required: true,
                message: "请输入设备mac码",
                trigger: "blur"
              }]
            },
            {
              label: "开门时间",
              prop: "openTime",
              rules: [{
                required: true,
                message: "请输入开门时间",
                trigger: "blur"
              }]
            },
            // {
            //   label: "机构路径",
            //   prop: "orgPosition",
            //   rules: [{
            //     required: true,
            //     message: "请输入机构路径",
            //     trigger: "blur"
            //   }]
            // },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.accessrecord_add, false),
          viewBtn: this.vaildData(this.permission.accessrecord_view, false),
          delBtn: this.vaildData(this.permission.accessrecord_delete, false),
          editBtn: this.vaildData(this.permission.accessrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
